diff --git a/configure.in b/configure.in
index b71e719..31f4539 100644
--- a/configure.in
+++ b/configure.in
@@ -182,9 +182,11 @@ if test x$enable_cp936 = xyes; then
 fi
 
 
-AC_ARG_ENABLE(gl, [  --enable-gl             turn on OpenGL support [default=yes]])
+AC_ARG_ENABLE(gl,         [  --enable-gl             turn on OpenGL support [default=yes]])
+
+AC_ARG_ENABLE(shared,     [  --enable-shared         turn on shared libraries [default=no]])
+AC_ARG_ENABLE(shared_opt, [  --enable-shared-opt     turn on shared libraries optimization [default=no]])
 
-AC_ARG_ENABLE(shared, [  --enable-shared         turn on shared libraries [default=no]])
 if test x$enable_shared = xyes; then
     PICFLAG=1
     SHAREDSUFFIX=""
@@ -253,7 +255,8 @@ if test x$enable_shared = xyes; then
             DSOCOMMAND="\$(CXX) \$(DSOFLAGS) -Wl,-soname,\$@ \$(LDLIBS) -shared -fPIC $DEBUGFLAG -o"
 
             # See if the compiler supports -fvisibility...
-            AC_CACHE_CHECK([if the compiler supports -fvisibility],
+	    if test x$enable_shared_opt = xyes; then
+              AC_CACHE_CHECK([if the compiler supports -fvisibility],
                 ac_cv_cxx_fvisibility, [
                     OLDCXXFLAGS="$CXXFLAGS"
                     CXXFLAGS="$CXXFLAGS -fvisibility=hidden"
@@ -264,13 +267,15 @@ if test x$enable_shared = xyes; then
                         ac_cv_cxx_fvisibility=no)
                     CXXFLAGS="$OLDCXXFLAGS"
                     AC_LANG_RESTORE
-            ])
-            if test x"$ac_cv_cxx_fvisibility" = xyes; then
+              ])
+              if test x"$ac_cv_cxx_fvisibility" = xyes; then
                 OPTIM="$OPTIM -fvisibility=hidden"
-            fi
+              fi
+	    fi
 
             # See if the compiler supports -fvisibility-inlines-hidden...
-            AC_CACHE_CHECK([if the compiler supports -fvisibility-inlines-hidden],
+	    if test x$enable_shared_opt = xyes; then
+              AC_CACHE_CHECK([if the compiler supports -fvisibility-inlines-hidden],
                 ac_cv_cxx_fvisibility_inlines, [
                     OLDCXXFLAGS="$CXXFLAGS"
                     CXXFLAGS="$CXXFLAGS -fvisibility-inlines-hidden"
@@ -281,9 +286,10 @@ if test x$enable_shared = xyes; then
                         ac_cv_cxx_fvisibility_inlines=no)
                     CXXFLAGS="$OLDCXXFLAGS"
                     AC_LANG_RESTORE
-            ])
-            if test x"$ac_cv_cxx_fvisibility_inlines" = xyes; then
+              ])
+              if test x"$ac_cv_cxx_fvisibility_inlines" = xyes; then
                 CXXFLAGS="$CXXFLAGS -fvisibility-inlines-hidden"
+              fi
             fi
 
 	    if test "x$libdir" != "x/usr/lib" -a "x$libdir" != "x/usr/lib64"; then
